#include <iostream>
#include <string>
#include <cmath>
#include <cctype>

#define asdigit(c) (c - '0')
#define LOG(x) cout << #x << "=" << (x) << endl;
#define S1 "    +";
#define S2 "+---+";
#define S3 "+   +";
#define D1 "    |";
#define D2 "|    ";
#define D3 "|   |";

using namespace std;

void analyze_pid(string word);
void test_digit(int beg, int num);
void comp(string str, string *A, set<int> posibble,int line); 

string word[7];
string S[3], D[3];
set<int> posibble, temp;

int main(int argc, char **argv) {
	S[0]=S1;S[1]=S2;S[2]=S3;D[0]=D1;D[1]=D2;D[2]=D3;
	while (true) {
		getline(cin, word[0]);
		if (word[0] == "end") break;
		for(int i=1; i<7; i++) getline(cin, word[i]);
		analyze_pid();
	}
	cout << "end" << endl;
	return 0;
}

void analyze_pid() {
	int a,b,c,d;	
	a=test_digit(0,5);
	b=test_digit(7,5);
	c=test_digit(17,5);
	d=test_digit(24,5);	
}

void test_digit(int beg, int num) {
	possible.clear();
	temp.clear();
	for (int i=0; i<7; i++) {
		if (i==0 || i==3 || i==6)
			comp(word[i].substr(beg, num), S, temp,i);
		else
			comp(word[i].substr(beg, num), D, temp,i);
		
	}
}

void comp(string str, string *A,int line) {
	for(int i=0; i<3; i++) {
		for(int  j=0; j<5; j++) {
			if(str.at(j) == '.' || str[j] == A[i].at(j))
				pos(line, A[i]);
		}
	}
}

void pos(int line, string str) {
	switch(line) {
	case 0 :
		if(str == S1) temp.insert(1);return;
		if(str == S3) temp.insert(4);return;
		temp.insert(2);temp.insert(3);temp.insert(5);temp.insert(6);
		temp.insert(7);temp.insert(8);temp.insert(9);temp.insert(0);
		return;
	case 1 :
	case 2 :
		switch(dig) {
 		case 1: case 2: case 7: case 3: 
			return D1;			
		case 5: case 6:
			return D2;
		case 4: case 8: case 9: case 0:
			return D3;	
		}
	case 3 :
		if(dig==1 || dig ==7) return S1;
		if(dig==0) return S3;
		return S2;
	case 4 :
	case 5 :
		switch(dig) {
 		case 1: case 4: case 5: case 7: case 9: case 3:
			return D1;			
		case 2: 
			return D2;
		case 6: case 8: case 0:
			return D3;	
		}
	case 6 :
		if(dig==1 || dig ==7 || dig ==4) return S1;
		return S2;
	}
}


	







